=== modified file 'buildout-templates/bin/kill-test-services.in'
--- buildout-templates/bin/kill-test-services.in	2011-12-29 05:29:36 +0000
+++ buildout-templates/bin/kill-test-services.in	2011-12-30 01:48:17 +0000
@@ -18,9 +18,9 @@
 
 import sys
 
+from lp.services.librarianserver.testing.server import LibrarianTestSetup
+from lp.services.osutils import kill_by_pidfile
 from lp.testing.layers import MemcachedLayer
-from canonical.librarian.testing.server import LibrarianTestSetup
-from lp.services.osutils import kill_by_pidfile
 
 
 def main(args):

=== modified file 'cronscripts/librarian-gc.py'
--- cronscripts/librarian-gc.py	2011-12-29 05:29:36 +0000
+++ cronscripts/librarian-gc.py	2011-12-30 01:48:17 +0000
@@ -19,9 +19,9 @@
 import _pythonpath
 
 from lp.services.config import config
-from canonical.librarian import librariangc
 from lp.services.database.lpstorm import IStore
 from lp.services.librarian.model import LibraryFileAlias
+from lp.services.librarianserver import librariangc
 from lp.services.scripts.base import LaunchpadCronScript
 
 

=== modified file 'cronscripts/parse-librarian-apache-access-logs.py'
--- cronscripts/parse-librarian-apache-access-logs.py	2011-12-29 05:29:36 +0000
+++ cronscripts/parse-librarian-apache-access-logs.py	2011-12-30 01:04:24 +0000
@@ -21,13 +21,13 @@
 from storm.sqlobject import SQLObjectNotFound
 from zope.component import getUtility
 
+from lp.services.apachelogparser.script import ParseApacheLogs
 from lp.services.config import config
-from lp.services.apachelogparser.script import ParseApacheLogs
-from lp.services.librarian.apachelogparser import (
+from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarianserver.apachelogparser import (
     DBUSER,
     get_library_file_id,
     )
-from lp.services.librarian.interfaces import ILibraryFileAliasSet
 
 
 class ParseLibrarianApacheLogs(ParseApacheLogs):

=== modified file 'daemons/librarian.tac'
--- daemons/librarian.tac	2011-12-29 05:29:36 +0000
+++ daemons/librarian.tac	2011-12-30 01:48:17 +0000
@@ -8,21 +8,31 @@
 import signal
 
 from meliae import scanner
-
-from twisted.application import service, strports
+from twisted.application import (
+    service,
+    strports,
+    )
 from twisted.internet import reactor
 from twisted.python import log
 from twisted.scripts.twistd import ServerOptions
 from twisted.web import server
 
-from lp.services.config import config, dbconfig
+from lp.services.config import (
+    config,
+    dbconfig,
+    )
 from lp.services.daemons import readyservice
+from lp.services.librarian.interfaces.client import (
+    DUMP_FILE,
+    SIGDUMPMEM,
+    )
+from lp.services.librarianserver import (
+    db,
+    storage,
+    web as fatweb,
+    )
+from lp.services.librarianserver.libraryprotocol import FileUploadFactory
 from lp.services.scripts import execute_zcml_for_scripts
-
-from canonical.librarian.interfaces import DUMP_FILE, SIGDUMPMEM
-from canonical.librarian.libraryprotocol import FileUploadFactory
-from canonical.librarian import storage, db
-from canonical.librarian import web as fatweb
 from lp.services.twistedsupport.loggingsupport import set_up_oops_reporting
 
 # Connect to database

=== modified file 'lib/canonical/configure.zcml'
--- lib/canonical/configure.zcml	2011-12-24 19:14:51 +0000
+++ lib/canonical/configure.zcml	2011-12-30 01:37:21 +0000
@@ -17,7 +17,6 @@
     <include package="lazr.restful" file="meta.zcml" />
     <include package="lazr.uri" />
     <include package="lp" />
-    <include package="canonical.librarian" />
 
     <!-- The default Zope 3 configuration of the SimpleComponentTraverser is
         that it applies to any object that provides Interface.

=== removed file 'lib/canonical/librarian/fatsam.dia'
Binary files lib/canonical/librarian/fatsam.dia and lib/canonical/librarian/fatsam.dia differ
=== removed directory 'lib/canonical/librarian/ftests'
=== removed file 'lib/canonical/librarian/ftests/__init__.py'
=== removed file 'lib/canonical/librarian/tests/test_upload.py'
--- lib/canonical/librarian/tests/test_upload.py	2011-12-22 11:12:50 +0000
+++ lib/canonical/librarian/tests/test_upload.py	1970-01-01 00:00:00 +0000
@@ -1,121 +0,0 @@
-# Copyright 2009 Canonical Ltd.  This software is licensed under the
-# GNU Affero General Public License version 3 (see the file LICENSE).
-
-__metaclass__ = type
-
-from canonical.librarian.libraryprotocol import FileUploadProtocol
-from canonical.librarian.storage import WrongDatabaseError
-from lp.testing.systemdocs import LayeredDocFileSuite
-
-
-class MockTransport:
-    disconnecting = False
-
-    bytesWritten = ''
-    connectionLost = False
-
-    def write(self, bytes):
-        self.bytesWritten += bytes
-
-    def loseConnection(self):
-        self.connectionLost = True
-        self.disconnecting = True
-
-
-class MockLibrary:
-    file = None
-    def startAddFile(self, name, size):
-        self.file = MockFile(name)
-        return self.file
-
-
-class MockFile:
-    bytes = ''
-    stored = False
-    databaseName = None
-    debugID = None
-    debugLog = ()
-
-    def __init__(self, name):
-        self.name = name
-
-    def append(self, bytes):
-        self.bytes += bytes
-
-    def store(self):
-        databaseName = self.databaseName
-        if databaseName is not None and databaseName != 'right_database':
-            raise WrongDatabaseError(databaseName, 'right_database')
-        self.stored = True
-        return (987, 654)
-
-
-def upload_request(request):
-    """Librarian upload server test helper, process a request and report what
-    happens.
-
-    Hands a request to a librarian file upload protocol, and prints the reply
-    from the server, a summary of the file uploaded, and whether the connection
-    closed, e.g.::
-
-        reply: '200'
-        file u'foo.txt' stored as text/plain, contents: 'Foo!'
-
-    or::
-
-        reply: '400 STORE command expects the filename to be in UTF-8'
-        connection closed
-
-    Note that the Librarian itself except for the protocol logic is stubbed out
-    by this function; it's intended to be used to unit test the protocol
-    implementation, not end-to-end test the Librarian.
-    """
-    # Send tracebacks from Twisted to stderr, if they occur, to make debugging
-    # test failures easier.
-    import sys
-    def log_observer(x):
-        print >> sys.stderr, x
-        if 'failure' in x:
-            x['failure'].printTraceback(file=sys.stderr)
-    from twisted.python import log
-    log.addObserver(log_observer)
-
-    # Create a FileUploadProtocol, and instrument it for testing:
-    server = FileUploadProtocol()
-
-    #  * hook _storeFile to dispatch straight to newFile.store without
-    #    spawning a thread.
-    from twisted.internet import defer
-    server._storeFile = lambda: defer.maybeDeferred(server.newFile.store)
-
-    #  * give it a fake transport
-    server.transport = MockTransport()
-    server.connectionMade()
-
-    #  * give it a fake factory (itself!), and a fake library.
-    server.factory = server
-    server.fileLibrary = MockLibrary()
-
-    # Feed in the request
-    server.dataReceived(request.replace('\n', '\r\n'))
-
-    # Report on what happened
-    print "reply: %r" % server.transport.bytesWritten.rstrip('\r\n')
-
-    if server.transport.connectionLost:
-        print 'connection closed'
-
-    mockFile = server.fileLibrary.file
-    if mockFile is not None and mockFile.stored:
-        print "file %r stored as %s, contents: %r" % (
-                mockFile.name, mockFile.mimetype, mockFile.bytes)
-
-    # Cleanup: remove the observer.
-    log.removeObserver(log_observer)
-
-
-def test_suite():
-    return LayeredDocFileSuite(
-        'test_upload.txt', globs={'upload_request': upload_request},
-        stdout_logging=False)
-

=== modified file 'lib/lp/archivepublisher/diskpool.py'
--- lib/lp/archivepublisher/diskpool.py	2010-08-24 10:45:57 +0000
+++ lib/lp/archivepublisher/diskpool.py	2011-12-30 01:10:37 +0000
@@ -6,11 +6,11 @@
 import os
 import tempfile
 
-from canonical.librarian.utils import (
+from lp.archivepublisher import HARDCODED_COMPONENT_ORDER
+from lp.services.librarian.utils import (
     copy_and_close,
     sha1_from_path,
     )
-from lp.archivepublisher import HARDCODED_COMPONENT_ORDER
 from lp.services.propertycache import cachedproperty
 from lp.soyuz.interfaces.publishing import (
     MissingSymlinkInPool,

=== modified file 'lib/lp/archivepublisher/publishing.py'
--- lib/lp/archivepublisher/publishing.py	2011-10-18 09:13:51 +0000
+++ lib/lp/archivepublisher/publishing.py	2011-12-30 01:10:37 +0000
@@ -22,7 +22,6 @@
     )
 
 from canonical.database.sqlbase import sqlvalues
-from canonical.librarian.client import LibrarianClient
 from lp.archivepublisher import HARDCODED_COMPONENT_ORDER
 from lp.archivepublisher.config import getPubConfig
 from lp.archivepublisher.diskpool import DiskPool
@@ -41,6 +40,7 @@
     RepositoryIndexFile,
     )
 from lp.registry.interfaces.pocket import PackagePublishingPocket
+from lp.services.librarian.client import LibrarianClient
 from lp.services.utils import file_exists
 from lp.soyuz.enums import (
     ArchivePurpose,

=== modified file 'lib/lp/archiveuploader/dscfile.py'
--- lib/lp/archiveuploader/dscfile.py	2011-12-21 07:54:40 +0000
+++ lib/lp/archiveuploader/dscfile.py	2011-12-30 01:10:37 +0000
@@ -29,7 +29,6 @@
 from debian.deb822 import Deb822Dict
 from zope.component import getUtility
 
-from canonical.librarian.utils import copy_and_close
 from lp.app.errors import NotFoundError
 from lp.archiveuploader.nascentuploadfile import (
     NascentUploadFile,
@@ -65,6 +64,7 @@
     GPGVerificationError,
     IGPGHandler,
     )
+from lp.services.librarian.utils import copy_and_close
 from lp.soyuz.enums import (
     ArchivePurpose,
     SourcePackageFormat,

=== modified file 'lib/lp/archiveuploader/nascentuploadfile.py'
--- lib/lp/archiveuploader/nascentuploadfile.py	2011-12-22 05:37:22 +0000
+++ lib/lp/archiveuploader/nascentuploadfile.py	2011-12-30 01:10:37 +0000
@@ -30,7 +30,6 @@
 from debian.deb822 import Deb822Dict
 from zope.component import getUtility
 
-from canonical.librarian.utils import filechunks
 from lp.app.errors import NotFoundError
 from lp.archiveuploader.utils import (
     determine_source_file_type,
@@ -47,6 +46,7 @@
 from lp.buildmaster.enums import BuildStatus
 from lp.services.encoding import guess as guess_encoding
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.utils import filechunks
 from lp.soyuz.enums import (
     BinaryPackageFormat,
     PackagePublishingPriority,

=== modified file 'lib/lp/archiveuploader/tests/__init__.py'
--- lib/lp/archiveuploader/tests/__init__.py	2010-12-22 01:08:48 +0000
+++ lib/lp/archiveuploader/tests/__init__.py	2011-12-30 01:48:17 +0000
@@ -16,12 +16,12 @@
 
 from zope.component import getGlobalSiteManager
 
-from canonical.librarian.testing.server import fillLibrarianFile
 from lp.archiveuploader.uploadpolicy import (
     AbstractUploadPolicy,
     findPolicyByName,
     IArchiveUploadPolicy,
     )
+from lp.services.librarianserver.testing.server import fillLibrarianFile
 from lp.soyuz.model.queue import PackageUploadSet
 
 

=== modified file 'lib/lp/buildmaster/model/builder.py'
--- lib/lp/buildmaster/model/builder.py	2011-12-29 05:29:36 +0000
+++ lib/lp/buildmaster/model/builder.py	2011-12-30 01:10:37 +0000
@@ -43,20 +43,10 @@
 from zope.component import getUtility
 from zope.interface import implements
 
-from lp.services.config import config
 from canonical.database.sqlbase import (
     SQLBase,
     sqlvalues,
     )
-from lp.services.helpers import filenameToContentType
-from lp.services.webapp import urlappend
-from lp.services.webapp.interfaces import (
-    DEFAULT_FLAVOR,
-    IStoreSelector,
-    MAIN_STORE,
-    SLAVE_FLAVOR,
-    )
-from canonical.librarian.utils import copy_and_close
 from lp.app.errors import NotFoundError
 from lp.buildmaster.interfaces.builder import (
     BuildDaemonError,
@@ -75,15 +65,25 @@
     specific_job_classes,
     )
 from lp.registry.interfaces.person import validate_public_person
+from lp.services.config import config
+from lp.services.helpers import filenameToContentType
 from lp.services.job.interfaces.job import JobStatus
 from lp.services.job.model.job import Job
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.utils import copy_and_close
 from lp.services.propertycache import (
     cachedproperty,
     get_property_cache,
     )
 from lp.services.twistedsupport import cancel_on_timeout
 from lp.services.twistedsupport.processmonitor import ProcessWithTimeout
+from lp.services.webapp import urlappend
+from lp.services.webapp.interfaces import (
+    DEFAULT_FLAVOR,
+    IStoreSelector,
+    MAIN_STORE,
+    SLAVE_FLAVOR,
+    )
 # XXX Michael Nelson 2010-01-13 bug=491330
 # These dependencies on soyuz will be removed when getBuildRecords()
 # is moved.

=== modified file 'lib/lp/buildmaster/model/buildfarmjobbehavior.py'
--- lib/lp/buildmaster/model/buildfarmjobbehavior.py	2011-12-19 17:39:16 +0000
+++ lib/lp/buildmaster/model/buildfarmjobbehavior.py	2011-12-30 02:24:09 +0000
@@ -17,12 +17,10 @@
 import xmlrpclib
 
 from twisted.internet import defer
-
 from zope.component import getUtility
 from zope.interface import implements
 from zope.security.proxy import removeSecurityProxy
 
-from canonical.librarian.interfaces import ILibrarianClient
 from lp.buildmaster.interfaces.builder import (
     BuildSlaveFailure,
     CorruptBuildCookie,
@@ -33,6 +31,7 @@
     )
 from lp.services import encoding
 from lp.services.job.interfaces.job import JobStatus
+from lp.services.librarian.interfaces.client import ILibrarianClient
 
 
 class BuildFarmJobBehaviorBase:

=== modified file 'lib/lp/code/model/tests/test_codeimportjob.py'
--- lib/lp/code/model/tests/test_codeimportjob.py	2011-12-29 05:29:36 +0000
+++ lib/lp/code/model/tests/test_codeimportjob.py	2011-12-30 02:24:09 +0000
@@ -19,14 +19,7 @@
 from zope.component import getUtility
 from zope.security.proxy import removeSecurityProxy
 
-from lp.services.config import config
 from canonical.database.constants import UTC_NOW
-from lp.services.webapp import canonical_url
-from canonical.librarian.interfaces import ILibrarianClient
-from lp.testing.layers import (
-    DatabaseFunctionalLayer,
-    LaunchpadFunctionalLayer,
-    )
 from lp.code.enums import (
     CodeImportEventType,
     CodeImportJobState,
@@ -46,7 +39,10 @@
     make_finished_import,
     make_running_import,
     )
+from lp.services.config import config
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.interfaces.client import ILibrarianClient
+from lp.services.webapp import canonical_url
 from lp.testing import (
     ANONYMOUS,
     login,
@@ -56,6 +52,10 @@
     with_anonymous_login,
     with_celebrity_logged_in,
     )
+from lp.testing.layers import (
+    DatabaseFunctionalLayer,
+    LaunchpadFunctionalLayer,
+    )
 from lp.testing.pages import get_feedback_messages
 
 

=== modified file 'lib/lp/codehosting/codeimport/workermonitor.py'
--- lib/lp/codehosting/codeimport/workermonitor.py	2011-12-29 05:29:36 +0000
+++ lib/lp/codehosting/codeimport/workermonitor.py	2011-12-30 02:24:09 +0000
@@ -22,15 +22,15 @@
 from twisted.web import xmlrpc
 from zope.component import getUtility
 
-from lp.services.config import config
-from lp.services.webapp import errorlog
-from lp.xmlrpc.faults import NoSuchCodeImportJob
-from canonical.librarian.interfaces import IFileUploadClient
 from lp.code.enums import CodeImportResultStatus
 from lp.codehosting.codeimport.worker import CodeImportWorkerExitCode
+from lp.services.config import config
+from lp.services.librarian.interfaces.client import IFileUploadClient
 from lp.services.twistedsupport.processmonitor import (
     ProcessMonitorProtocolWithTimeout,
     )
+from lp.services.webapp import errorlog
+from lp.xmlrpc.faults import NoSuchCodeImportJob
 
 
 class CodeImportWorkerMonitorProtocol(ProcessMonitorProtocolWithTimeout):

=== modified file 'lib/lp/hardwaredb/doc/hwdb-submission.txt'
--- lib/lp/hardwaredb/doc/hwdb-submission.txt	2011-12-29 05:29:36 +0000
+++ lib/lp/hardwaredb/doc/hwdb-submission.txt	2011-12-30 01:48:17 +0000
@@ -253,7 +253,7 @@
 let's add one. Let's add invalid data in order to see how invalid
 submissions are processed.
 
-    >>> from canonical.librarian.testing.server import fillLibrarianFile
+    >>> from lp.services.librarianserver.testing.server import fillLibrarianFile
     >>> submission = submission_set.getBySubmissionKey('test_submission_id_1')
     >>> fillLibrarianFile(
     ...     submission.raw_submission.id, 'nonsense')

=== modified file 'lib/lp/hardwaredb/scripts/hwdbsubmissions.py'
--- lib/lp/hardwaredb/scripts/hwdbsubmissions.py	2011-12-29 05:29:36 +0000
+++ lib/lp/hardwaredb/scripts/hwdbsubmissions.py	2011-12-30 02:24:09 +0000
@@ -32,17 +32,7 @@
 from zope.interface import implements
 from zope.security.proxy import removeSecurityProxy
 
-from lp.services.config import config
-from lp.services.looptuner import (
-    ITunableLoop,
-    LoopTuner,
-    )
-from lp.services.webapp.errorlog import (
-    ErrorReportingUtility,
-    ScriptRequest,
-    )
 from canonical.lazr.xml import RelaxNGValidator
-from canonical.librarian.interfaces import LibrarianServerError
 from lp.app.interfaces.launchpad import ILaunchpadCelebrities
 from lp.hardwaredb.interfaces.hwdb import (
     HWBus,
@@ -56,8 +46,18 @@
     IHWVendorNameSet,
     )
 from lp.hardwaredb.model.hwdb import HWSubmission
+from lp.services.config import config
+from lp.services.librarian.interfaces.client import LibrarianServerError
+from lp.services.looptuner import (
+    ITunableLoop,
+    LoopTuner,
+    )
 from lp.services.propertycache import cachedproperty
 from lp.services.scripts.base import disable_oops_handler
+from lp.services.webapp.errorlog import (
+    ErrorReportingUtility,
+    ScriptRequest,
+    )
 
 
 _relax_ng_files = {

=== modified file 'lib/lp/hardwaredb/scripts/tests/test_hwdb_submission_processing.py'
--- lib/lp/hardwaredb/scripts/tests/test_hwdb_submission_processing.py	2011-12-29 05:29:36 +0000
+++ lib/lp/hardwaredb/scripts/tests/test_hwdb_submission_processing.py	2011-12-30 01:48:17 +0000
@@ -14,13 +14,6 @@
 from zope.component import getUtility
 from zope.testing.loghandler import Handler
 
-from lp.services.config import config
-from canonical.librarian.interfaces import LibrarianServerError
-from canonical.librarian.testing.server import fillLibrarianFile
-from lp.testing.layers import (
-    BaseLayer,
-    LaunchpadZopelessLayer,
-    )
 from lp.app.interfaces.launchpad import ILaunchpadCelebrities
 from lp.hardwaredb.interfaces.hwdb import (
     HWBus,
@@ -47,10 +40,17 @@
     SubmissionParser,
     UdevDevice,
     )
+from lp.services.config import config
+from lp.services.librarian.interfaces.client import LibrarianServerError
+from lp.services.librarianserver.testing.server import fillLibrarianFile
 from lp.testing import (
     TestCase,
     validate_mock_class,
     )
+from lp.testing.layers import (
+    BaseLayer,
+    LaunchpadZopelessLayer,
+    )
 
 
 def evaluate_property(value):

=== modified file 'lib/lp/scripts/utilities/importfascist.py'
--- lib/lp/scripts/utilities/importfascist.py	2011-12-24 16:23:17 +0000
+++ lib/lp/scripts/utilities/importfascist.py	2011-12-30 01:48:17 +0000
@@ -40,8 +40,8 @@
     lp.services.worlddata.vocabularies
     lp.soyuz.vocabularies
     lp.translations.vocabularies
-    canonical.librarian.client
-    canonical.librarian.db
+    lp.services.librarian.client
+    lp.services.librarianserver.db
     doctest
     """)
 

=== modified file 'lib/lp/services/apachelogparser/tests/test_apachelogparser.py'
--- lib/lp/services/apachelogparser/tests/test_apachelogparser.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/apachelogparser/tests/test_apachelogparser.py	2011-12-30 01:04:24 +0000
@@ -10,16 +10,6 @@
 
 from zope.component import getUtility
 
-from lp.services.config import config
-from lp.services.webapp.interfaces import (
-    DEFAULT_FLAVOR,
-    IStoreSelector,
-    MAIN_STORE,
-    )
-from lp.testing.layers import (
-    LaunchpadZopelessLayer,
-    ZopelessLayer,
-    )
 from lp.services.apachelogparser.base import (
     create_or_update_parsedlog_entry,
     get_day,
@@ -30,9 +20,19 @@
     parse_file,
     )
 from lp.services.apachelogparser.model.parsedapachelog import ParsedApacheLog
-from lp.services.librarian.apachelogparser import DBUSER
+from lp.services.config import config
+from lp.services.librarianserver.apachelogparser import DBUSER
 from lp.services.log.logger import BufferLogger
+from lp.services.webapp.interfaces import (
+    DEFAULT_FLAVOR,
+    IStoreSelector,
+    MAIN_STORE,
+    )
 from lp.testing import TestCase
+from lp.testing.layers import (
+    LaunchpadZopelessLayer,
+    ZopelessLayer,
+    )
 
 
 here = os.path.dirname(__file__)

=== modified file 'lib/lp/services/database/tests/test_transaction_decorators.py'
--- lib/lp/services/database/tests/test_transaction_decorators.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/database/tests/test_transaction_decorators.py	2011-12-30 01:48:17 +0000
@@ -6,18 +6,18 @@
 import transaction
 from zope.component import getUtility
 
+from lp.services.database import (
+    read_transaction,
+    write_transaction,
+    )
+from lp.services.librarian.model import LibraryFileContent
+from lp.services.librarianserver import db
 from lp.services.webapp.interfaces import (
     DEFAULT_FLAVOR,
     IStoreSelector,
     MAIN_STORE,
     )
-from canonical.librarian import db
 from lp.testing.layers import LaunchpadZopelessLayer
-from lp.services.database import (
-    read_transaction,
-    write_transaction,
-    )
-from lp.services.librarian.model import LibraryFileContent
 
 
 class TestTransactionDecorators(unittest.TestCase):

=== modified file 'lib/lp/services/librarian/browser.py'
--- lib/lp/services/librarian/browser.py	2011-12-24 17:49:30 +0000
+++ lib/lp/services/librarian/browser.py	2011-12-30 01:10:37 +0000
@@ -19,7 +19,10 @@
 from zope.publisher.interfaces import NotFound
 from zope.security.interfaces import Unauthorized
 
+from lp.app.errors import GoneError
 from lp.layers import WebServiceLayer
+from lp.services.librarian.client import url_path_quote
+from lp.services.librarian.interfaces import ILibraryFileAlias
 from lp.services.webapp.authorization import check_permission
 from lp.services.webapp.publisher import (
     canonical_url,
@@ -28,9 +31,6 @@
     stepthrough,
     )
 from lp.services.webapp.url import urlappend
-from canonical.librarian.client import url_path_quote
-from lp.app.errors import GoneError
-from lp.services.librarian.interfaces import ILibraryFileAlias
 
 
 class LibraryFileAliasView(LaunchpadView):

=== renamed file 'lib/canonical/librarian/client.py' => 'lib/lp/services/librarian/client.py'
--- lib/canonical/librarian/client.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarian/client.py	2011-12-30 02:24:09 +0000
@@ -35,17 +35,12 @@
 from zope.component import getUtility
 from zope.interface import implements
 
+from canonical.database.postgresql import ConnectionString
 from lp.services.config import (
     config,
     dbconfig,
     )
-from canonical.database.postgresql import ConnectionString
-from lp.services.webapp.interfaces import (
-    IStoreSelector,
-    MAIN_STORE,
-    MASTER_FLAVOR,
-    )
-from canonical.librarian.interfaces import (
+from lp.services.librarian.interfaces.client import (
     DownloadFailed,
     ILibrarianClient,
     IRestrictedLibrarianClient,
@@ -54,6 +49,11 @@
     UploadFailed,
     )
 from lp.services.timeline.requesttimeline import get_request_timeline
+from lp.services.webapp.interfaces import (
+    IStoreSelector,
+    MAIN_STORE,
+    MASTER_FLAVOR,
+    )
 
 
 def url_path_quote(filename):

=== renamed file 'lib/canonical/librarian/configure.zcml' => 'lib/lp/services/librarian/client.zcml'
--- lib/canonical/librarian/configure.zcml	2009-07-13 18:15:02 +0000
+++ lib/lp/services/librarian/client.zcml	2011-12-30 01:37:21 +0000
@@ -10,14 +10,14 @@
 
     <securedutility
         class=".client.LibrarianClient"
-        provides=".interfaces.ILibrarianClient">
-        <allow interface=".interfaces.ILibrarianClient" />
+        provides=".interfaces.client.ILibrarianClient">
+        <allow interface=".interfaces.client.ILibrarianClient" />
     </securedutility>
 
     <securedutility
         class=".client.RestrictedLibrarianClient"
-        provides=".interfaces.IRestrictedLibrarianClient">
-        <allow interface=".interfaces.IRestrictedLibrarianClient" />
+        provides=".interfaces.client.IRestrictedLibrarianClient">
+        <allow interface=".interfaces.client.IRestrictedLibrarianClient" />
     </securedutility>
 </configure>
 

=== modified file 'lib/lp/services/librarian/configure.zcml'
--- lib/lp/services/librarian/configure.zcml	2011-12-22 05:37:22 +0000
+++ lib/lp/services/librarian/configure.zcml	2011-12-30 01:37:21 +0000
@@ -8,6 +8,8 @@
     xmlns:zope="http://namespaces.zope.org/zope"
     i18n_domain="launchpad">
 
+  <include file="client.zcml" />
+
   <class class="lp.services.librarian.model.LibraryFileAlias">
     <allow interface="lp.services.librarian.interfaces.ILibraryFileAlias" />
   </class>

=== modified file 'lib/lp/services/librarian/doc/librarian.txt'
--- lib/lp/services/librarian/doc/librarian.txt	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarian/doc/librarian.txt	2011-12-30 01:14:33 +0000
@@ -216,7 +216,7 @@
 We can also use the ILibrarianClient Utility directly to store and
 access files in the Librarian.
 
-    >>> from canonical.librarian.interfaces import ILibrarianClient
+    >>> from lp.services.librarian.interfaces.client import ILibrarianClient
     >>> client = getUtility(ILibrarianClient)
     >>> aid = client.addFile(
     ...     'text.txt', len(data), StringIO(data), 'text/plain', NEVER_EXPIRES
@@ -317,7 +317,7 @@
 librarian.
 
     >>> from zope.interface.verify import verifyObject
-    >>> from canonical.librarian.interfaces import IRestrictedLibrarianClient
+    >>> from lp.services.librarian.interfaces.client import IRestrictedLibrarianClient
     >>> restricted_client = getUtility(IRestrictedLibrarianClient)
     >>> verifyObject(IRestrictedLibrarianClient, restricted_client)
     True
@@ -393,7 +393,7 @@
 But using the restricted librarian will work:
 
     >>> restricted_client.getFileByAlias(private_file_id)
-    <canonical.librarian.client._File...>
+    <lp.services.librarian.client._File...>
 
     >>> file_url = restricted_client.getURLForAlias(private_file_id)
     >>> print file_url

=== added directory 'lib/lp/services/librarian/interfaces'
=== renamed file 'lib/lp/services/librarian/interfaces.py' => 'lib/lp/services/librarian/interfaces/__init__.py'
--- lib/lp/services/librarian/interfaces.py	2011-12-24 16:54:44 +0000
+++ lib/lp/services/librarian/interfaces/__init__.py	2011-12-30 02:24:09 +0000
@@ -34,7 +34,9 @@
     )
 
 from lp import _
-from canonical.librarian.interfaces import LIBRARIAN_SERVER_DEFAULT_TIMEOUT
+from lp.services.librarian.interfaces.client import (
+    LIBRARIAN_SERVER_DEFAULT_TIMEOUT,
+    )
 
 # Set the expires attribute to this constant to flag a file that
 # should never be removed from the Librarian.

=== renamed file 'lib/canonical/librarian/interfaces.py' => 'lib/lp/services/librarian/interfaces/client.py'
=== modified file 'lib/lp/services/librarian/model.py'
--- lib/lp/services/librarian/model.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarian/model.py	2011-12-30 02:24:09 +0000
@@ -46,7 +46,6 @@
     Interface,
     )
 
-from lp.services.config import config
 from canonical.database.constants import (
     DEFAULT,
     UTC_NOW,
@@ -56,12 +55,7 @@
     session_store,
     SQLBase,
     )
-from canonical.librarian.interfaces import (
-    DownloadFailed,
-    ILibrarianClient,
-    IRestrictedLibrarianClient,
-    LIBRARIAN_SERVER_DEFAULT_TIMEOUT,
-    )
+from lp.services.config import config
 from lp.services.database.lpstorm import IMasterStore
 from lp.services.database.stormbase import StormBase
 from lp.services.librarian.interfaces import (
@@ -71,6 +65,12 @@
     ILibraryFileContent,
     ILibraryFileDownloadCount,
     )
+from lp.services.librarian.interfaces.client import (
+    DownloadFailed,
+    ILibrarianClient,
+    IRestrictedLibrarianClient,
+    LIBRARIAN_SERVER_DEFAULT_TIMEOUT,
+    )
 
 
 class LibraryFileContent(SQLBase):

=== renamed file 'lib/canonical/librarian/smoketest.py' => 'lib/lp/services/librarian/smoketest.py' (properties changed: +x to -x)
=== renamed file 'lib/canonical/librarian/ftests/test_client.py' => 'lib/lp/services/librarian/tests/test_client.py'
--- lib/canonical/librarian/ftests/test_client.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarian/tests/test_client.py	2011-12-30 01:37:21 +0000
@@ -11,22 +11,22 @@
 
 import transaction
 
+from canonical.database.sqlbase import block_implicit_flushes
 from lp.services.config import config
-from canonical.database.sqlbase import block_implicit_flushes
-from lp.services.webapp.dbpolicy import SlaveDatabasePolicy
-from canonical.librarian import client as client_module
-from canonical.librarian.client import (
+from lp.services.database.lpstorm import ISlaveStore
+from lp.services.librarian import client as client_module
+from lp.services.librarian.client import (
     LibrarianClient,
     LibrarianServerError,
     RestrictedLibrarianClient,
     )
-from canonical.librarian.interfaces import UploadFailed
+from lp.services.librarian.interfaces.client import UploadFailed
+from lp.services.librarian.model import LibraryFileAlias
+from lp.services.webapp.dbpolicy import SlaveDatabasePolicy
 from lp.testing.layers import (
     DatabaseLayer,
     LaunchpadFunctionalLayer,
     )
-from lp.services.database.lpstorm import ISlaveStore
-from lp.services.librarian.model import LibraryFileAlias
 
 
 class InstrumentedLibrarianClient(LibrarianClient):

=== renamed file 'lib/canonical/librarian/tests/test_smoketest.py' => 'lib/lp/services/librarian/tests/test_smoketest.py'
--- lib/canonical/librarian/tests/test_smoketest.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarian/tests/test_smoketest.py	2011-12-30 01:48:17 +0000
@@ -5,18 +5,18 @@
 
 __metaclass__ = type
 
+from contextlib import contextmanager
 from cStringIO import StringIO
-from contextlib import contextmanager
 
-from canonical.librarian import smoketest
-from canonical.librarian.smoketest import (
+from lp.services.librarian import smoketest
+from lp.services.librarian.smoketest import (
     do_smoketest,
     FILE_DATA,
     store_file,
     )
-from canonical.librarian.testing.fake import FakeLibrarian
+from lp.services.librarianserver.testing.fake import FakeLibrarian
+from lp.testing import TestCaseWithFactory
 from lp.testing.layers import ZopelessDatabaseLayer
-from lp.testing import TestCaseWithFactory
 
 
 class GoodUrllib:

=== renamed file 'lib/canonical/librarian/tests/test_utils.py' => 'lib/lp/services/librarian/tests/test_utils.py'
--- lib/canonical/librarian/tests/test_utils.py	2011-08-12 11:19:40 +0000
+++ lib/lp/services/librarian/tests/test_utils.py	2011-12-30 01:10:37 +0000
@@ -3,7 +3,7 @@
 
 import unittest
 
-from canonical.librarian.utils import guess_librarian_encoding
+from lp.services.librarian.utils import guess_librarian_encoding
 
 
 class LibrarianUtils(unittest.TestCase):

=== renamed file 'lib/canonical/librarian/utils.py' => 'lib/lp/services/librarian/utils.py'
=== renamed directory 'lib/canonical/librarian' => 'lib/lp/services/librarianserver'
=== renamed file 'lib/lp/services/librarian/apachelogparser.py' => 'lib/lp/services/librarianserver/apachelogparser.py'
=== added directory 'lib/lp/services/librarianserver/doc'
=== renamed file 'lib/canonical/librarian/tests/librarian-report.txt' => 'lib/lp/services/librarianserver/doc/librarian-report.txt'
=== renamed file 'lib/canonical/librarian/tests/test_upload.txt' => 'lib/lp/services/librarianserver/doc/upload.txt'
=== modified file 'lib/lp/services/librarianserver/librariangc.py'
--- lib/canonical/librarian/librariangc.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarianserver/librariangc.py	2011-12-30 01:48:17 +0000
@@ -5,24 +5,33 @@
 
 __metaclass__ = type
 
-from datetime import datetime, timedelta
+from datetime import (
+    datetime,
+    timedelta,
+    )
 import errno
+import os
 import re
 import sys
 from time import time
-import os
 
 from zope.interface import implements
 
+from canonical.database.postgresql import (
+    drop_tables,
+    listReferences,
+    quoteIdentifier,
+    )
 from lp.services.config import config
-from canonical.database.postgresql import drop_tables, quoteIdentifier
+from lp.services.librarianserver.storage import (
+    _relFileLocation as relative_file_path,
+    _sameFile,
+    )
 from lp.services.looptuner import (
     DBLoopTuner,
     ITunableLoop,
     )
-from canonical.librarian.storage import _relFileLocation as relative_file_path
-from canonical.librarian.storage import _sameFile
-from canonical.database.postgresql import listReferences
+
 
 log = None  # This is set by cronscripts/librarian-gc.py
 debug = False

=== modified file 'lib/lp/services/librarianserver/libraryprotocol.py'
--- lib/canonical/librarian/libraryprotocol.py	2011-09-26 07:33:00 +0000
+++ lib/lp/services/librarianserver/libraryprotocol.py	2011-12-30 01:48:17 +0000
@@ -11,7 +11,7 @@
 from twisted.protocols import basic
 from twisted.python import log
 
-from canonical.librarian.storage import WrongDatabaseError
+from lp.services.librarianserver.storage import WrongDatabaseError
 
 
 class ProtocolViolation(Exception):

=== modified file 'lib/lp/services/librarianserver/testing/fake.py'
--- lib/canonical/librarian/testing/fake.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarianserver/testing/fake.py	2011-12-30 02:24:09 +0000
@@ -26,12 +26,12 @@
 from zope.interface import implements
 
 from lp.services.config import config
-from canonical.librarian.client import get_libraryfilealias_download_path
-from canonical.librarian.interfaces import (
+from lp.services.librarian.client import get_libraryfilealias_download_path
+from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.interfaces.client import (
     ILibrarianClient,
     LIBRARIAN_SERVER_DEFAULT_TIMEOUT,
     )
-from lp.services.librarian.interfaces import ILibraryFileAliasSet
 from lp.services.librarian.model import (
     LibraryFileAlias,
     LibraryFileContent,

=== modified file 'lib/lp/services/librarianserver/testing/server.py'
--- lib/canonical/librarian/testing/server.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarianserver/testing/server.py	2011-12-30 01:48:17 +0000
@@ -26,7 +26,7 @@
     TacException,
     TacTestSetup,
     )
-from canonical.librarian.storage import _relFileLocation
+from lp.services.librarianserver.storage import _relFileLocation
 from lp.services.osutils import get_pid_from_file
 
 
@@ -158,12 +158,12 @@
         #2010-10-20 14:28:21+0530 [-] Log opened.
         #2010-10-20 14:28:21+0530 [-] twistd 10.1.0 (/usr/bin/python 2.6.5) starting up.
         #2010-10-20 14:28:21+0530 [-] reactor class: twisted.internet.selectreactor.SelectReactor.
-        #2010-10-20 14:28:21+0530 [-] canonical.librarian.libraryprotocol.FileUploadFactory starting on 59090
-        #2010-10-20 14:28:21+0530 [-] Starting factory <canonical.librarian.libraryprotocol.FileUploadFactory instance at 0x6f8ff38>
+        #2010-10-20 14:28:21+0530 [-] lp.services.librarianserver.libraryprotocol.FileUploadFactory starting on 59090
+        #2010-10-20 14:28:21+0530 [-] Starting factory <lp.services.librarianserver.libraryprotocol.FileUploadFactory instance at 0x6f8ff38>
         #2010-10-20 14:28:21+0530 [-] twisted.web.server.Site starting on 58000
         #2010-10-20 14:28:21+0530 [-] Starting factory <twisted.web.server.Site instance at 0x6fb2638>
-        #2010-10-20 14:28:21+0530 [-] canonical.librarian.libraryprotocol.FileUploadFactory starting on 59095
-        #2010-10-20 14:28:21+0530 [-] Starting factory <canonical.librarian.libraryprotocol.FileUploadFactory instance at 0x6fb25f0>
+        #2010-10-20 14:28:21+0530 [-] lp.services.librarianserver.libraryprotocol.FileUploadFactory starting on 59095
+        #2010-10-20 14:28:21+0530 [-] Starting factory <lp.services.librarianserver.libraryprotocol.FileUploadFactory instance at 0x6fb25f0>
         #2010-10-20 14:28:21+0530 [-] twisted.web.server.Site starting on 58005
         self.upload_port = int(chunks[3].split()[-1])
         self.download_port = int(chunks[5].split()[-1])

=== modified file 'lib/lp/services/librarianserver/testing/tests/test_fakelibrarian.py'
--- lib/canonical/librarian/testing/tests/test_fakelibrarian.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarianserver/testing/tests/test_fakelibrarian.py	2011-12-30 01:48:17 +0000
@@ -12,20 +12,20 @@
 from zope.component import getUtility
 from zope.security.proxy import removeSecurityProxy
 
-from lp.services.webapp.testing import verifyObject
-from canonical.librarian.client import LibrarianClient
-from canonical.librarian.interfaces import ILibrarianClient
-from canonical.librarian.testing.fake import FakeLibrarian
-from lp.testing.layers import (
-    DatabaseFunctionalLayer,
-    LaunchpadFunctionalLayer,
-    )
+from lp.services.librarian.client import LibrarianClient
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.interfaces.client import ILibrarianClient
 from lp.services.librarian.model import (
     LibraryFileAlias,
     LibraryFileAliasSet,
     )
+from lp.services.librarianserver.testing.fake import FakeLibrarian
+from lp.services.webapp.testing import verifyObject
 from lp.testing import TestCaseWithFactory
+from lp.testing.layers import (
+    DatabaseFunctionalLayer,
+    LaunchpadFunctionalLayer,
+    )
 
 
 class LibraryAccessScenarioMixin:

=== modified file 'lib/lp/services/librarianserver/testing/tests/test_server_fixture.py'
--- lib/canonical/librarian/testing/tests/test_server_fixture.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarianserver/testing/tests/test_server_fixture.py	2011-12-30 01:48:17 +0000
@@ -8,22 +8,25 @@
 __metaclass__ = type
 
 import os
-from urllib import urlopen
 import socket
 from textwrap import dedent
+from urllib import urlopen
 
 from testtools.content import Content
 from testtools.content_type import UTF8_TEXT
 
 from lp.services.config import config
 from lp.services.config.fixture import ConfigFixture
-from canonical.librarian.testing.server import LibrarianServerFixture
+from lp.services.librarianserver.testing.server import LibrarianServerFixture
+from lp.testing import TestCase
+from lp.testing.layers import (
+    BaseLayer,
+    DatabaseLayer,
+    )
 from lp.testing.tests.test_layers_functional import (
     BaseLayerIsolator,
     LayerFixture,
     )
-from lp.testing.layers import BaseLayer, DatabaseLayer
-from lp.testing import TestCase
 
 
 class TestLibrarianServerFixture(TestCase):

=== renamed file 'lib/lp/services/librarian/tests/test_apachelogparser.py' => 'lib/lp/services/librarianserver/tests/test_apachelogparser.py'
--- lib/lp/services/librarian/tests/test_apachelogparser.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarianserver/tests/test_apachelogparser.py	2011-12-30 01:48:17 +0000
@@ -8,22 +8,22 @@
 
 from zope.component import getUtility
 
+from lp.services.apachelogparser.base import (
+    get_method_and_path,
+    parse_file,
+    )
+from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarianserver.apachelogparser import get_library_file_id
+from lp.services.log.logger import BufferLogger
 from lp.testing import (
     ANONYMOUS,
     login,
+    TestCase,
     )
 from lp.testing.layers import (
     DatabaseFunctionalLayer,
     ZopelessLayer,
     )
-from lp.services.apachelogparser.base import (
-    get_method_and_path,
-    parse_file,
-    )
-from lp.services.librarian.apachelogparser import get_library_file_id
-from lp.services.librarian.interfaces import ILibraryFileAliasSet
-from lp.services.log.logger import BufferLogger
-from lp.testing import TestCase
 
 
 here = os.path.dirname(__file__)

=== renamed file 'lib/canonical/librarian/ftests/test_db.py' => 'lib/lp/services/librarianserver/tests/test_db.py'
--- lib/canonical/librarian/ftests/test_db.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarianserver/tests/test_db.py	2011-12-30 02:19:42 +0000
@@ -6,14 +6,14 @@
 import transaction
 from zope.component import getUtility
 
+from lp.services.librarian.model import LibraryFileContent
+from lp.services.librarianserver import db
 from lp.services.webapp.interfaces import (
     DEFAULT_FLAVOR,
     IStoreSelector,
     MAIN_STORE,
     )
-from canonical.librarian import db
 from lp.testing.layers import LaunchpadZopelessLayer
-from lp.services.librarian.model import LibraryFileContent
 
 
 class DBTestCase(unittest.TestCase):

=== modified file 'lib/lp/services/librarianserver/tests/test_db_outage.py'
--- lib/canonical/librarian/tests/test_db_outage.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarianserver/tests/test_db_outage.py	2011-12-30 01:48:17 +0000
@@ -12,14 +12,14 @@
 
 from fixtures import Fixture
 
-from canonical.librarian.client import LibrarianClient
-from canonical.librarian.testing.server import LibrarianServerFixture
+from lp.services.librarian.client import LibrarianClient
+from lp.services.librarianserver.testing.server import LibrarianServerFixture
+from lp.testing import TestCase
+from lp.testing.fixture import PGBouncerFixture
 from lp.testing.layers import (
     BaseLayer,
     DatabaseFunctionalLayer,
     )
-from lp.testing import TestCase
-from lp.testing.fixture import PGBouncerFixture
 
 
 class PGBouncerLibrarianLayer(DatabaseFunctionalLayer):

=== modified file 'lib/lp/services/librarianserver/tests/test_doc.py'
--- lib/canonical/librarian/tests/test_doc.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarianserver/tests/test_doc.py	2011-12-30 02:24:09 +0000
@@ -5,10 +5,14 @@
 Run the doctests and pagetests.
 """
 
+__metaclass__ = type
+
 import os
 
+from lp.services.librarianserver.libraryprotocol import FileUploadProtocol
+from lp.services.librarianserver.storage import WrongDatabaseError
+from lp.services.testing import build_test_suite
 from lp.testing.layers import LaunchpadZopelessLayer
-from lp.services.testing import build_test_suite
 from lp.testing.systemdocs import (
     LayeredDocFileSuite,
     setUp,
@@ -16,14 +20,126 @@
     )
 
 
+class MockTransport:
+    disconnecting = False
+
+    bytesWritten = ''
+    connectionLost = False
+
+    def write(self, bytes):
+        self.bytesWritten += bytes
+
+    def loseConnection(self):
+        self.connectionLost = True
+        self.disconnecting = True
+
+
+class MockLibrary:
+    file = None
+    def startAddFile(self, name, size):
+        self.file = MockFile(name)
+        return self.file
+
+
+class MockFile:
+    bytes = ''
+    stored = False
+    databaseName = None
+    debugID = None
+    debugLog = ()
+
+    def __init__(self, name):
+        self.name = name
+
+    def append(self, bytes):
+        self.bytes += bytes
+
+    def store(self):
+        databaseName = self.databaseName
+        if databaseName is not None and databaseName != 'right_database':
+            raise WrongDatabaseError(databaseName, 'right_database')
+        self.stored = True
+        return (987, 654)
+
+
+def upload_request(request):
+    """Librarian upload server test helper, process a request and report what
+    happens.
+
+    Hands a request to a librarian file upload protocol, and prints the reply
+    from the server, a summary of the file uploaded, and whether the connection
+    closed, e.g.::
+
+        reply: '200'
+        file u'foo.txt' stored as text/plain, contents: 'Foo!'
+
+    or::
+
+        reply: '400 STORE command expects the filename to be in UTF-8'
+        connection closed
+
+    Note that the Librarian itself except for the protocol logic is stubbed out
+    by this function; it's intended to be used to unit test the protocol
+    implementation, not end-to-end test the Librarian.
+    """
+    # Send tracebacks from Twisted to stderr, if they occur, to make debugging
+    # test failures easier.
+    import sys
+    def log_observer(x):
+        print >> sys.stderr, x
+        if 'failure' in x:
+            x['failure'].printTraceback(file=sys.stderr)
+    from twisted.python import log
+    log.addObserver(log_observer)
+
+    # Create a FileUploadProtocol, and instrument it for testing:
+    server = FileUploadProtocol()
+
+    #  * hook _storeFile to dispatch straight to newFile.store without
+    #    spawning a thread.
+    from twisted.internet import defer
+    server._storeFile = lambda: defer.maybeDeferred(server.newFile.store)
+
+    #  * give it a fake transport
+    server.transport = MockTransport()
+    server.connectionMade()
+
+    #  * give it a fake factory (itself!), and a fake library.
+    server.factory = server
+    server.fileLibrary = MockLibrary()
+
+    # Feed in the request
+    server.dataReceived(request.replace('\n', '\r\n'))
+
+    # Report on what happened
+    print "reply: %r" % server.transport.bytesWritten.rstrip('\r\n')
+
+    if server.transport.connectionLost:
+        print 'connection closed'
+
+    mockFile = server.fileLibrary.file
+    if mockFile is not None and mockFile.stored:
+        print "file %r stored as %s, contents: %r" % (
+                mockFile.name, mockFile.mimetype, mockFile.bytes)
+
+    # Cleanup: remove the observer.
+    log.removeObserver(log_observer)
+
+
 here = os.path.dirname(os.path.realpath(__file__))
 
 special = {
     'librarian-report.txt': LayeredDocFileSuite(
-            'librarian-report.txt',
+            '../doc/librarian-report.txt',
             setUp=setUp, tearDown=tearDown,
             layer=LaunchpadZopelessLayer
             ),
+    'upload.txt': LayeredDocFileSuite(
+            '../doc/upload.txt',
+            setUp=setUp, tearDown=tearDown,
+            layer=LaunchpadZopelessLayer,
+            globs={'upload_request': upload_request},
+            ),
 }
 
 def test_suite():

=== renamed file 'lib/canonical/librarian/ftests/test_gc.py' => 'lib/lp/services/librarianserver/tests/test_gc.py'
--- lib/canonical/librarian/ftests/test_gc.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarianserver/tests/test_gc.py	2011-12-30 02:19:42 +0000
@@ -20,22 +20,22 @@
 from sqlobject import SQLObjectNotFound
 import transaction
 
-from lp.services.config import config
 from canonical.database.sqlbase import (
     connect,
     cursor,
     ISOLATION_LEVEL_AUTOCOMMIT,
     )
-from canonical.librarian import librariangc
-from canonical.librarian.client import LibrarianClient
-from lp.testing.layers import LaunchpadZopelessLayer
+from lp.services.config import config
+from lp.services.librarian.client import LibrarianClient
 from lp.services.librarian.model import (
     LibraryFileAlias,
     LibraryFileContent,
     )
+from lp.services.librarianserver import librariangc
 from lp.services.log.logger import BufferLogger
 from lp.services.utils import utc_now
 from lp.testing import TestCase
+from lp.testing.layers import LaunchpadZopelessLayer
 
 
 class TestLibrarianGarbageCollection(TestCase):

=== modified file 'lib/lp/services/librarianserver/tests/test_sigdumpmem.py'
--- lib/canonical/librarian/tests/test_sigdumpmem.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarianserver/tests/test_sigdumpmem.py	2011-12-30 02:24:09 +0000
@@ -8,9 +8,12 @@
 import os
 import time
 
-from canonical.librarian.interfaces import DUMP_FILE, SIGDUMPMEM
+from lp.services.librarian.interfaces.client import (
+    DUMP_FILE,
+    SIGDUMPMEM,
+    )
+from lp.testing import TestCase
 from lp.testing.layers import LibrarianLayer
-from lp.testing import TestCase
 
 
 class SIGDUMPMEMTestCase(TestCase):

=== modified file 'lib/lp/services/librarianserver/tests/test_storage.py'
--- lib/canonical/librarian/tests/test_storage.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarianserver/tests/test_storage.py	2011-12-30 01:48:17 +0000
@@ -8,11 +8,17 @@
 
 from zope.component import getUtility
 
+from lp.services.librarianserver import db
+from lp.services.librarianserver.storage import (
+    _relFileLocation,
+    _sameFile,
+    LibrarianStorage,
+    )
 from lp.services.webapp.interfaces import (
-        IStoreSelector, MAIN_STORE, DEFAULT_FLAVOR)
-from canonical.librarian.storage import LibrarianStorage
-from canonical.librarian.storage import _sameFile, _relFileLocation
-from canonical.librarian import db
+    DEFAULT_FLAVOR,
+    IStoreSelector,
+    MAIN_STORE,
+    )
 from lp.testing.layers import LaunchpadZopelessLayer
 
 

=== renamed file 'lib/canonical/librarian/ftests/test_storage.py' => 'lib/lp/services/librarianserver/tests/test_storage_db.py'
--- lib/canonical/librarian/ftests/test_storage.py	2011-12-28 17:03:06 +0000
+++ lib/lp/services/librarianserver/tests/test_storage_db.py	2011-12-30 02:19:42 +0000
@@ -7,15 +7,15 @@
 import unittest
 
 from canonical.database.sqlbase import flush_database_updates
-from canonical.librarian import db
-from canonical.librarian.storage import (
+from lp.services.librarian.model import LibraryFileContent
+from lp.services.librarianserver import db
+from lp.services.librarianserver.storage import (
     DigestMismatchError,
     DuplicateFileIDError,
     LibrarianStorage,
     LibraryFileUpload,
     )
 from lp.testing.layers import LaunchpadZopelessLayer
-from lp.services.librarian.model import LibraryFileContent
 
 
 class LibrarianStorageDBTests(unittest.TestCase):

=== renamed file 'lib/canonical/librarian/ftests/test_web.py' => 'lib/lp/services/librarianserver/tests/test_web.py'
--- lib/canonical/librarian/ftests/test_web.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarianserver/tests/test_web.py	2011-12-30 02:24:09 +0000
@@ -17,27 +17,27 @@
 import transaction
 from zope.component import getUtility
 
-from lp.services.config import config
 from canonical.database.sqlbase import (
     cursor,
     flush_database_updates,
     session_store,
     )
-from canonical.librarian.client import (
+from lp.services.config import config
+from lp.services.database.lpstorm import IMasterStore
+from lp.services.librarian.client import (
     get_libraryfilealias_download_path,
     LibrarianClient,
     )
-from canonical.librarian.interfaces import DownloadFailed
-from lp.testing.layers import (
-    LaunchpadFunctionalLayer,
-    LaunchpadZopelessLayer,
-    )
-from lp.services.database.lpstorm import IMasterStore
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.interfaces.client import DownloadFailed
 from lp.services.librarian.model import (
     LibraryFileAlias,
     TimeLimitedToken,
     )
+from lp.testing.layers import (
+    LaunchpadFunctionalLayer,
+    LaunchpadZopelessLayer,
+    )
 
 
 def uri_path_replace(url, old, new):

=== modified file 'lib/lp/services/librarianserver/web.py'
--- lib/canonical/librarian/web.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/librarianserver/web.py	2011-12-30 01:10:37 +0000
@@ -8,17 +8,23 @@
 from urlparse import urlparse
 
 from storm.exceptions import DisconnectionError
+from twisted.internet.threads import deferToThread
 from twisted.python import log
-from twisted.web import resource, static, util, server, proxy
-from twisted.internet.threads import deferToThread
+from twisted.web import (
+    proxy,
+    resource,
+    server,
+    static,
+    util,
+    )
 
 from lp.services.config import config
-from canonical.librarian.client import url_path_quote
 from lp.services.database import (
     read_transaction,
     write_transaction,
     )
-from canonical.librarian.utils import guess_librarian_encoding
+from lp.services.librarian.client import url_path_quote
+from lp.services.librarian.utils import guess_librarian_encoding
 
 
 defaultResource = static.Data("""

=== modified file 'lib/lp/services/mail/incoming.py'
--- lib/lp/services/mail/incoming.py	2011-12-24 17:49:30 +0000
+++ lib/lp/services/mail/incoming.py	2011-12-30 02:24:09 +0000
@@ -26,19 +26,6 @@
     directlyProvides,
     )
 
-from lp.services.mail.notification import (
-    send_process_error_notification,
-    )
-from lp.services.webapp.errorlog import (
-    ErrorReportingUtility,
-    ScriptRequest,
-    )
-from lp.services.webapp.interaction import (
-    get_current_principal,
-    setupInteraction,
-    )
-from lp.services.webapp.interfaces import IPlacelessAuthUtility
-from canonical.librarian.interfaces import UploadFailed
 from lp.registry.interfaces.person import IPerson
 from lp.services.features import getFeatureFlag
 from lp.services.gpg.interfaces import (
@@ -46,6 +33,7 @@
     IGPGHandler,
     )
 from lp.services.identity.interfaces.account import AccountStatus
+from lp.services.librarian.interfaces.client import UploadFailed
 from lp.services.mail.handlers import mail_handlers
 from lp.services.mail.helpers import (
     ensure_sane_signature_timestamp,
@@ -54,8 +42,18 @@
     )
 from lp.services.mail.interfaces import IWeaklyAuthenticatedPrincipal
 from lp.services.mail.mailbox import IMailBox
+from lp.services.mail.notification import send_process_error_notification
 from lp.services.mail.sendmail import do_paranoid_envelope_to_validation
 from lp.services.mail.signedmessage import signed_message_from_string
+from lp.services.webapp.errorlog import (
+    ErrorReportingUtility,
+    ScriptRequest,
+    )
+from lp.services.webapp.interaction import (
+    get_current_principal,
+    setupInteraction,
+    )
+from lp.services.webapp.interfaces import IPlacelessAuthUtility
 
 # Match '\n' and '\r' line endings. That is, all '\r' that are not
 # followed by a '\n', and all '\n' that are not preceded by a '\r'.

=== modified file 'lib/lp/services/scripts/logger.py'
--- lib/lp/services/scripts/logger.py	2011-12-29 05:29:36 +0000
+++ lib/lp/services/scripts/logger.py	2011-12-30 02:24:09 +0000
@@ -46,11 +46,7 @@
 from zope.exceptions.log import Formatter
 
 from lp.services.config import config
-from lp.services.webapp.errorlog import (
-    globalErrorUtility,
-    ScriptRequest,
-    )
-from canonical.librarian.interfaces import (
+from lp.services.librarian.interfaces.client import (
     ILibrarianClient,
     UploadFailed,
     )
@@ -59,6 +55,10 @@
     compress_hash,
     utc_now,
     )
+from lp.services.webapp.errorlog import (
+    globalErrorUtility,
+    ScriptRequest,
+    )
 
 # Reexport our custom loglevels for old callsites. These callsites
 # should be importing the symbols from lp.services.log.loglevels

=== modified file 'lib/lp/services/temporaryblobstorage/browser.py'
--- lib/lp/services/temporaryblobstorage/browser.py	2011-12-24 17:49:30 +0000
+++ lib/lp/services/temporaryblobstorage/browser.py	2011-12-30 02:24:09 +0000
@@ -13,6 +13,12 @@
 from zope.component import getUtility
 from zope.interface import implements
 
+from lp.app.browser.launchpadform import (
+    action,
+    LaunchpadFormView,
+    )
+from lp.bugs.interfaces.apportjob import IProcessApportBlobJobSource
+from lp.services.librarian.interfaces.client import UploadFailed
 from lp.services.temporaryblobstorage.interfaces import (
     BlobTooLarge,
     ITemporaryBlobStorage,
@@ -20,12 +26,6 @@
     )
 from lp.services.webapp import GetitemNavigation
 from lp.services.webapp.interfaces import ICanonicalUrlData
-from canonical.librarian.interfaces import UploadFailed
-from lp.app.browser.launchpadform import (
-    action,
-    LaunchpadFormView,
-    )
-from lp.bugs.interfaces.apportjob import IProcessApportBlobJobSource
 
 
 class TemporaryBlobStorageAddView(LaunchpadFormView):

=== modified file 'lib/lp/services/twistedsupport/loggingsupport.py'
--- lib/lp/services/twistedsupport/loggingsupport.py	2011-12-24 17:49:30 +0000
+++ lib/lp/services/twistedsupport/loggingsupport.py	2011-12-30 01:10:37 +0000
@@ -31,9 +31,9 @@
 from twisted.web import xmlrpc
 from zope.interface import implements
 
+from lp.services.librarian.utils import copy_and_close
 from lp.services.scripts import logger
 from lp.services.webapp import errorlog
-from canonical.librarian.utils import copy_and_close
 
 
 def set_up_logging_for_script(options, name, logfile):

=== modified file 'lib/lp/soyuz/doc/distroseriesqueue-notify.txt'
--- lib/lp/soyuz/doc/distroseriesqueue-notify.txt	2011-12-28 17:03:06 +0000
+++ lib/lp/soyuz/doc/distroseriesqueue-notify.txt	2011-12-30 01:48:17 +0000
@@ -203,7 +203,7 @@
 (which is not the case when nascent upload runs).  This example
 demonstrates this usage:
 
-    >>> from canonical.librarian.testing.server import fillLibrarianFile
+    >>> from lp.services.librarianserver.testing.server import fillLibrarianFile
     >>> changes_file = open(changes_file_path,"r")
     >>> fillLibrarianFile(1, content=changes_file.read())
     >>> changes_file.close()

=== modified file 'lib/lp/soyuz/doc/package-diff.txt'
--- lib/lp/soyuz/doc/package-diff.txt	2011-12-24 17:49:30 +0000
+++ lib/lp/soyuz/doc/package-diff.txt	2011-12-30 01:48:17 +0000
@@ -277,7 +277,7 @@
     >>> import subprocess
     >>> import tempfile
 
-    >>> from canonical.librarian.utils import copy_and_close
+    >>> from lp.services.librarian.utils import copy_and_close
 
     >>> def get_diff_results(diff):
     ...     lfa = diff.diff_content
@@ -643,7 +643,7 @@
     ...     '1.0-2', archive=foobar.archive)
     >>> transaction.commit()
 
-    >>> from canonical.librarian.testing.server import fillLibrarianFile
+    >>> from lp.services.librarianserver.testing.server import fillLibrarianFile
     >>> [orig, upload_diff, dsc] = pub.sourcepackagerelease.files
     >>> fillLibrarianFile(dsc.libraryfile.id)
 

=== modified file 'lib/lp/soyuz/doc/soyuz-set-of-uploads.txt'
--- lib/lp/soyuz/doc/soyuz-set-of-uploads.txt	2011-12-29 05:29:36 +0000
+++ lib/lp/soyuz/doc/soyuz-set-of-uploads.txt	2011-12-30 01:48:17 +0000
@@ -101,7 +101,7 @@
 
 Add disk content for file inherited from ubuntu/breezy-autotest:
 
-    >>> from canonical.librarian.testing.server import fillLibrarianFile
+    >>> from lp.services.librarianserver.testing.server import fillLibrarianFile
     >>> fillLibrarianFile(54)
 
 Now that the infrastructure is ready, we prepare a set of useful methods.

=== modified file 'lib/lp/soyuz/model/packagediff.py'
--- lib/lp/soyuz/model/packagediff.py	2011-12-24 17:49:30 +0000
+++ lib/lp/soyuz/model/packagediff.py	2011-12-30 01:10:37 +0000
@@ -27,12 +27,6 @@
     SQLBase,
     sqlvalues,
     )
-from lp.services.webapp.interfaces import (
-    DEFAULT_FLAVOR,
-    IStoreSelector,
-    MAIN_STORE,
-    )
-from canonical.librarian.utils import copy_and_close
 from lp.services.database.bulk import load
 from lp.services.database.decoratedresultset import DecoratedResultSet
 from lp.services.database.lpstorm import IStore
@@ -41,6 +35,12 @@
     LibraryFileAlias,
     LibraryFileContent,
     )
+from lp.services.librarian.utils import copy_and_close
+from lp.services.webapp.interfaces import (
+    DEFAULT_FLAVOR,
+    IStoreSelector,
+    MAIN_STORE,
+    )
 from lp.soyuz.enums import PackageDiffStatus
 from lp.soyuz.interfaces.packagediff import (
     IPackageDiff,

=== modified file 'lib/lp/soyuz/model/queue.py'
--- lib/lp/soyuz/model/queue.py	2011-12-29 05:29:36 +0000
+++ lib/lp/soyuz/model/queue.py	2011-12-30 02:24:09 +0000
@@ -39,7 +39,6 @@
 from zope.component import getUtility
 from zope.interface import implements
 
-from lp.services.config import config
 from canonical.database.constants import UTC_NOW
 from canonical.database.datetimecol import UtcDateTimeCol
 from canonical.database.enumcol import EnumCol
@@ -47,8 +46,6 @@
     SQLBase,
     sqlvalues,
     )
-from canonical.librarian.interfaces import DownloadFailed
-from canonical.librarian.utils import copy_and_close
 from lp.app.errors import NotFoundError
 # XXX 2009-05-10 julian
 # This should not import from archivepublisher, but to avoid
@@ -59,11 +56,14 @@
 from lp.archiveuploader.tagfiles import parse_tagfile_content
 from lp.registry.interfaces.pocket import PackagePublishingPocket
 from lp.registry.model.sourcepackagename import SourcePackageName
+from lp.services.config import config
 from lp.services.database.lpstorm import (
     IMasterStore,
     IStore,
     )
+from lp.services.librarian.interfaces.client import DownloadFailed
 from lp.services.librarian.model import LibraryFileAlias
+from lp.services.librarian.utils import copy_and_close
 from lp.services.mail.signedmessage import strip_pgp_signature
 from lp.services.propertycache import cachedproperty
 from lp.soyuz.adapters.notification import notify

=== modified file 'lib/lp/soyuz/scripts/ftpmaster.py'
--- lib/lp/soyuz/scripts/ftpmaster.py	2011-12-23 23:44:59 +0000
+++ lib/lp/soyuz/scripts/ftpmaster.py	2011-12-30 02:24:09 +0000
@@ -28,12 +28,6 @@
 from zope.component import getUtility
 
 from canonical.database.constants import UTC_NOW
-from lp.services.helpers import filenameToContentType
-from canonical.librarian.interfaces import (
-    ILibrarianClient,
-    UploadFailed,
-    )
-from canonical.librarian.utils import copy_and_close
 from lp.app.errors import NotFoundError
 from lp.archiveuploader.utils import determine_source_file_type
 from lp.registry.interfaces.person import IPersonSet
@@ -41,7 +35,13 @@
 from lp.registry.interfaces.series import SeriesStatus
 from lp.registry.interfaces.sourcepackage import SourcePackageFileType
 from lp.services.browser_helpers import get_plural_text
+from lp.services.helpers import filenameToContentType
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.interfaces.client import (
+    ILibrarianClient,
+    UploadFailed,
+    )
+from lp.services.librarian.utils import copy_and_close
 from lp.services.scripts.base import (
     LaunchpadScript,
     LaunchpadScriptFailure,

=== modified file 'lib/lp/soyuz/scripts/packagecopier.py'
--- lib/lp/soyuz/scripts/packagecopier.py	2011-12-22 05:37:22 +0000
+++ lib/lp/soyuz/scripts/packagecopier.py	2011-12-30 01:10:37 +0000
@@ -24,10 +24,10 @@
 from lazr.delegates import delegates
 from zope.component import getUtility
 
-from canonical.librarian.utils import copy_and_close
 from lp.app.errors import NotFoundError
 from lp.buildmaster.enums import BuildStatus
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.utils import copy_and_close
 from lp.soyuz.adapters.notification import notify
 from lp.soyuz.adapters.packagelocation import build_package_location
 from lp.soyuz.enums import (

=== modified file 'lib/lp/soyuz/scripts/queue.py'
--- lib/lp/soyuz/scripts/queue.py	2011-12-29 05:29:36 +0000
+++ lib/lp/soyuz/scripts/queue.py	2011-12-30 01:10:37 +0000
@@ -23,10 +23,10 @@
 import pytz
 from zope.component import getUtility
 
-from lp.services.config import config
-from canonical.librarian.utils import filechunks
 from lp.app.browser.tales import DurationFormatterAPI
 from lp.app.errors import NotFoundError
+from lp.services.config import config
+from lp.services.librarian.utils import filechunks
 from lp.services.propertycache import cachedproperty
 from lp.soyuz.enums import PackageUploadStatus
 from lp.soyuz.interfaces.component import IComponentSet

=== modified file 'lib/lp/soyuz/scripts/tests/test_copypackage.py'
--- lib/lp/soyuz/scripts/tests/test_copypackage.py	2011-12-29 05:29:36 +0000
+++ lib/lp/soyuz/scripts/tests/test_copypackage.py	2011-12-30 01:48:17 +0000
@@ -21,14 +21,7 @@
 from zope.component import getUtility
 from zope.security.proxy import removeSecurityProxy
 
-from lp.services.config import config
 from canonical.database.sqlbase import flush_database_caches
-from canonical.librarian.testing.server import fillLibrarianFile
-from lp.testing.layers import (
-    DatabaseLayer,
-    LaunchpadFunctionalLayer,
-    LaunchpadZopelessLayer,
-    )
 from lp.archivepublisher.utils import get_ppa_reference
 from lp.bugs.interfaces.bug import (
     CreateBugParams,
@@ -40,7 +33,9 @@
 from lp.registry.interfaces.person import IPersonSet
 from lp.registry.interfaces.pocket import PackagePublishingPocket
 from lp.registry.interfaces.series import SeriesStatus
+from lp.services.config import config
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarianserver.testing.server import fillLibrarianFile
 from lp.services.log.logger import BufferLogger
 from lp.soyuz.adapters.overrides import SourceOverride
 from lp.soyuz.adapters.packagelocation import PackageLocationError
@@ -88,6 +83,11 @@
     StormStatementRecorder,
     TestCaseWithFactory,
     )
+from lp.testing.layers import (
+    DatabaseLayer,
+    LaunchpadFunctionalLayer,
+    LaunchpadZopelessLayer,
+    )
 from lp.testing.mail_helpers import pop_notifications
 from lp.testing.matchers import HasQueryCount
 

=== modified file 'lib/lp/soyuz/scripts/tests/test_queue.py'
--- lib/lp/soyuz/scripts/tests/test_queue.py	2011-12-29 05:29:36 +0000
+++ lib/lp/soyuz/scripts/tests/test_queue.py	2011-12-30 01:48:17 +0000
@@ -17,14 +17,6 @@
 from zope.security.interfaces import ForbiddenAttribute
 from zope.security.proxy import removeSecurityProxy
 
-from lp.services.config import config
-from canonical.librarian.testing.server import fillLibrarianFile
-from canonical.librarian.utils import filechunks
-from lp.testing.layers import (
-    DatabaseFunctionalLayer,
-    LaunchpadZopelessLayer,
-    LibrarianLayer,
-    )
 from lp.archiveuploader.nascentupload import NascentUpload
 from lp.archiveuploader.tests import (
     datadir,
@@ -40,9 +32,12 @@
 from lp.registry.interfaces.person import IPersonSet
 from lp.registry.interfaces.pocket import PackagePublishingPocket
 from lp.registry.interfaces.series import SeriesStatus
+from lp.services.config import config
 from lp.services.database.lpstorm import IStore
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
 from lp.services.librarian.model import LibraryFileAlias
+from lp.services.librarian.utils import filechunks
+from lp.services.librarianserver.testing.server import fillLibrarianFile
 from lp.services.log.logger import DevNullLogger
 from lp.services.mail import stub
 from lp.soyuz.enums import (
@@ -69,6 +64,11 @@
     TestCaseWithFactory,
     )
 from lp.testing.fakemethod import FakeMethod
+from lp.testing.layers import (
+    DatabaseFunctionalLayer,
+    LaunchpadZopelessLayer,
+    LibrarianLayer,
+    )
 
 
 class TestQueueBase:

=== modified file 'lib/lp/soyuz/scripts/tests/test_sync_source.py'
--- lib/lp/soyuz/scripts/tests/test_sync_source.py	2011-12-29 05:29:36 +0000
+++ lib/lp/soyuz/scripts/tests/test_sync_source.py	2011-12-30 01:48:17 +0000
@@ -19,14 +19,10 @@
 import transaction
 from zope.component import getUtility
 
-from lp.services.config import config
-from canonical.librarian.testing.server import fillLibrarianFile
-from lp.testing.layers import (
-    LaunchpadZopelessLayer,
-    LibrarianLayer,
-    )
 from lp.archiveuploader.tagfiles import parse_tagfile
 from lp.registry.interfaces.distribution import IDistributionSet
+from lp.services.config import config
+from lp.services.librarianserver.testing.server import fillLibrarianFile
 from lp.services.log.logger import BufferLogger
 from lp.soyuz.scripts.ftpmaster import (
     generate_changes,
@@ -37,6 +33,10 @@
     TestCase,
     TestCaseWithFactory,
     )
+from lp.testing.layers import (
+    LaunchpadZopelessLayer,
+    LibrarianLayer,
+    )
 
 
 class TestSyncSource(TestCaseWithFactory):

=== modified file 'lib/lp/soyuz/stories/soyuz/xx-package-diff.txt'
--- lib/lp/soyuz/stories/soyuz/xx-package-diff.txt	2011-06-28 15:04:29 +0000
+++ lib/lp/soyuz/stories/soyuz/xx-package-diff.txt	2011-12-30 01:14:33 +0000
@@ -98,7 +98,7 @@
     >>> from zope.security.proxy import removeSecurityProxy
     >>> from StringIO import StringIO
     >>> from canonical.database.constants import UTC_NOW
-    >>> from canonical.librarian.interfaces import ILibrarianClient
+    >>> from lp.services.librarian.interfaces.client import ILibrarianClient
     >>> from lp.soyuz.enums import PackageDiffStatus
 
     >>> def perform_fake_diff(diff, filename):

=== modified file 'lib/lp/soyuz/stories/soyuz/xx-queue-pages.txt'
--- lib/lp/soyuz/stories/soyuz/xx-queue-pages.txt	2011-12-28 17:03:06 +0000
+++ lib/lp/soyuz/stories/soyuz/xx-queue-pages.txt	2011-12-30 01:14:33 +0000
@@ -183,7 +183,7 @@
     >>> from zope.security.proxy import removeSecurityProxy
     >>> from StringIO import StringIO
     >>> from canonical.database.constants import UTC_NOW
-    >>> from canonical.librarian.interfaces import ILibrarianClient
+    >>> from lp.services.librarian.interfaces.client import ILibrarianClient
     >>> from lp.soyuz.enums import PackageDiffStatus
     >>> login(ANONYMOUS)
     >>> old = main_archive.getPublishedSources(

=== modified file 'lib/lp/testing/fakelibrarian.py'
--- lib/lp/testing/fakelibrarian.py	2010-09-26 18:40:23 +0000
+++ lib/lp/testing/fakelibrarian.py	2011-12-30 01:48:17 +0000
@@ -1,16 +1,18 @@
 # Copyright 2010 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
-"""See canonical.librarian.testing.fake."""
+"""See lp.services.librarianserver.testing.fake."""
 
 import warnings
 
-from canonical.librarian.testing.fake import FakeLibrarian as _FakeLibrarian
+from lp.services.librarianserver.testing.fake import (
+    FakeLibrarian as _FakeLibrarian,
+    )
 
 
 def FakeLibrarian(*args, **kwargs):
     """Forward to the new home with a deprecation warning."""
     warnings.warn("Stale import: please import FakeLibrarian from "
-        "canonical.librarian.testing.fake instead.", DeprecationWarning,
+        "lp.services.librarianserver.testing.fake instead.", DeprecationWarning,
         stacklevel=2)
     return _FakeLibrarian(*args, **kwargs)

=== modified file 'lib/lp/testing/layers.py'
--- lib/lp/testing/layers.py	2011-12-29 05:40:17 +0000
+++ lib/lp/testing/layers.py	2011-12-30 01:48:17 +0000
@@ -101,44 +101,27 @@
     )
 from zope.server.logger.pythonlogger import PythonLogger
 
-from lp.services.config import (
-    LaunchpadConfig,
-    config,
-    dbconfig,
-    )
-from lp.services.config.fixture import (
-    ConfigFixture,
-    ConfigUseFixture,
-    )
 from canonical.database.sqlbase import session_store
-from lp.services.scripts import execute_zcml_for_scripts
-from lp.services.webapp.authorization import (
-    LaunchpadPermissiveSecurityPolicy,
-    )
-from lp.services.webapp.interfaces import (
-    DEFAULT_FLAVOR,
-    IOpenLaunchBag,
-    IStoreSelector,
-    MAIN_STORE,
-    )
-from lp.services.webapp.servers import (
-    LaunchpadAccessLogger,
-    register_launchpad_request_publication_factories,
-    )
-import lp.services.webapp.session
 from canonical.lazr import pidfile
 from canonical.lazr.testing.layers import MockRootFolder
 from canonical.lazr.timeout import (
     get_default_timeout_function,
     set_default_timeout_function,
     )
-from canonical.librarian.testing.server import LibrarianServerFixture
-from lp.testing import reset_logging
 from canonical.testing.profiled import profiled
-from lp.testing.smtpd import SMTPController
+from lp.services.config import (
+    config,
+    dbconfig,
+    LaunchpadConfig,
+    )
+from lp.services.config.fixture import (
+    ConfigFixture,
+    ConfigUseFixture,
+    )
 from lp.services.googlesearch.tests.googleserviceharness import (
     GoogleServiceTestSetup,
     )
+from lp.services.librarianserver.testing.server import LibrarianServerFixture
 from lp.services.mail.mailbox import (
     IMailBox,
     TestMailBox,
@@ -148,13 +131,28 @@
 from lp.services.memcache.client import memcache_client_factory
 from lp.services.osutils import kill_by_pidfile
 from lp.services.rabbit.server import RabbitServer
+from lp.services.scripts import execute_zcml_for_scripts
+from lp.services.webapp.authorization import LaunchpadPermissiveSecurityPolicy
+from lp.services.webapp.interfaces import (
+    DEFAULT_FLAVOR,
+    IOpenLaunchBag,
+    IStoreSelector,
+    MAIN_STORE,
+    )
+from lp.services.webapp.servers import (
+    LaunchpadAccessLogger,
+    register_launchpad_request_publication_factories,
+    )
+import lp.services.webapp.session
 from lp.testing import (
     ANONYMOUS,
     login,
     logout,
+    reset_logging,
     )
 from lp.testing.dbuser import switch_dbuser
 from lp.testing.pgsql import PgTestSetup
+from lp.testing.smtpd import SMTPController
 
 
 orig__call__ = zope.app.testing.functional.HTTPCaller.__call__

=== modified file 'lib/lp/testing/librarianhelpers.py'
--- lib/lp/testing/librarianhelpers.py	2011-12-24 17:49:30 +0000
+++ lib/lp/testing/librarianhelpers.py	2011-12-30 02:24:09 +0000
@@ -11,13 +11,13 @@
 from storm.expr import Desc
 from zope.component import getUtility
 
+from lp.services.librarian.interfaces.client import ILibrarianClient
+from lp.services.librarian.model import LibraryFileAlias
 from lp.services.webapp.interfaces import (
     DEFAULT_FLAVOR,
     IStoreSelector,
     MAIN_STORE,
     )
-from canonical.librarian.interfaces import ILibrarianClient
-from lp.services.librarian.model import LibraryFileAlias
 
 
 def get_newest_librarian_file():

=== modified file 'lib/lp/testing/tests/test_layers_functional.py'
--- lib/lp/testing/tests/test_layers_functional.py	2011-12-29 05:29:36 +0000
+++ lib/lp/testing/tests/test_layers_functional.py	2011-12-30 02:24:09 +0000
@@ -31,13 +31,14 @@
     getUtility,
     )
 
+from canonical.lazr.pidfile import pidfile_path
 from lp.services.config import config
-from canonical.lazr.pidfile import pidfile_path
-from canonical.librarian.client import (
+from lp.services.librarian.client import (
     LibrarianClient,
     UploadFailed,
     )
-from canonical.librarian.interfaces import ILibrarianClient
+from lp.services.librarian.interfaces.client import ILibrarianClient
+from lp.services.memcache.client import memcache_client_factory
 from lp.testing.layers import (
     AppServerLayer,
     BaseLayer,
@@ -56,7 +57,6 @@
     RabbitMQLayer,
     ZopelessLayer,
     )
-from lp.services.memcache.client import memcache_client_factory
 
 
 class BaseLayerIsolator(Fixture):

=== modified file 'lib/lp/translations/doc/language-pack.txt'
--- lib/lp/translations/doc/language-pack.txt	2011-12-24 17:49:30 +0000
+++ lib/lp/translations/doc/language-pack.txt	2011-12-30 01:14:33 +0000
@@ -17,7 +17,7 @@
     ...     ILanguagePack,
     ...     ILanguagePackSet)
     >>> from lp.services.webapp.testing import verifyObject
-    >>> from canonical.librarian.interfaces import ILibrarianClient
+    >>> from lp.services.librarian.interfaces.client import ILibrarianClient
 
 Let's upload a dummy file to librarian.
 

=== modified file 'lib/lp/translations/doc/poexport-language-pack.txt'
--- lib/lp/translations/doc/poexport-language-pack.txt	2011-12-24 15:18:32 +0000
+++ lib/lp/translations/doc/poexport-language-pack.txt	2011-12-30 01:14:33 +0000
@@ -15,7 +15,7 @@
     >>> from lp.translations.scripts.language_pack import (
     ...    export_language_pack)
     >>> from canonical.database.sqlbase import flush_database_caches
-    >>> from canonical.librarian.interfaces import ILibrarianClient
+    >>> from lp.services.librarian.interfaces.client import ILibrarianClient
     >>> rosetta_experts = getUtility(ILaunchpadCelebrities).rosetta_experts
     >>> login("daf@canonical.com")
 

=== modified file 'lib/lp/translations/model/translationimportqueue.py'
--- lib/lp/translations/model/translationimportqueue.py	2011-12-21 14:58:31 +0000
+++ lib/lp/translations/model/translationimportqueue.py	2011-12-30 02:24:09 +0000
@@ -55,12 +55,6 @@
     SQLBase,
     sqlvalues,
     )
-from lp.services.database.lpstorm import (
-    IMasterStore,
-    ISlaveStore,
-    IStore,
-    )
-from canonical.librarian.interfaces import ILibrarianClient
 from lp.app.errors import NotFoundError
 from lp.app.interfaces.launchpad import ILaunchpadCelebrities
 from lp.app.interfaces.security import IAuthorization
@@ -75,6 +69,12 @@
 from lp.registry.interfaces.role import IPersonRoles
 from lp.registry.interfaces.series import SeriesStatus
 from lp.registry.interfaces.sourcepackage import ISourcePackage
+from lp.services.database.lpstorm import (
+    IMasterStore,
+    ISlaveStore,
+    IStore,
+    )
+from lp.services.librarian.interfaces.client import ILibrarianClient
 from lp.services.worlddata.interfaces.language import ILanguageSet
 from lp.translations.enums import RosettaImportStatus
 from lp.translations.interfaces.pofile import IPOFileSet

=== modified file 'lib/lp/translations/scripts/language_pack.py'
--- lib/lp/translations/scripts/language_pack.py	2011-12-19 23:38:16 +0000
+++ lib/lp/translations/scripts/language_pack.py	2011-12-30 02:24:09 +0000
@@ -26,11 +26,11 @@
     cursor,
     sqlvalues,
     )
-from canonical.librarian.interfaces import (
+from lp.registry.interfaces.distribution import IDistributionSet
+from lp.services.librarian.interfaces.client import (
     ILibrarianClient,
     UploadFailed,
     )
-from lp.registry.interfaces.distribution import IDistributionSet
 from lp.services.tarfile_helpers import LaunchpadWriteTarFile
 from lp.translations.enums import LanguagePackType
 from lp.translations.interfaces.languagepack import ILanguagePackSet

=== modified file 'lib/lp/translations/tests/test_exportresult.py'
--- lib/lp/translations/tests/test_exportresult.py	2011-12-28 17:03:06 +0000
+++ lib/lp/translations/tests/test_exportresult.py	2011-12-30 01:48:17 +0000
@@ -9,10 +9,10 @@
 import os.path
 from StringIO import StringIO
 
-from canonical.librarian.testing.fake import FakeLibrarian
-from lp.testing.layers import ZopelessDatabaseLayer
+from lp.services.librarianserver.testing.fake import FakeLibrarian
 from lp.services.log.logger import DevNullLogger
 from lp.testing import TestCaseWithFactory
+from lp.testing.layers import ZopelessDatabaseLayer
 from lp.translations.scripts.po_export_queue import ExportResult
 
 

=== modified file 'lib/lp/translations/tests/test_translationbranchapprover.py'
--- lib/lp/translations/tests/test_translationbranchapprover.py	2011-12-28 17:03:06 +0000
+++ lib/lp/translations/tests/test_translationbranchapprover.py	2011-12-30 01:48:17 +0000
@@ -8,14 +8,14 @@
 import transaction
 from zope.component import getUtility
 
-from canonical.librarian.testing.fake import FakeLibrarian
+from lp.app.interfaces.launchpad import ILaunchpadCelebrities
+from lp.app.validators.name import valid_name
+from lp.services.librarianserver.testing.fake import FakeLibrarian
+from lp.testing import TestCaseWithFactory
 from lp.testing.layers import (
     LaunchpadZopelessLayer,
     ZopelessDatabaseLayer,
     )
-from lp.app.interfaces.launchpad import ILaunchpadCelebrities
-from lp.app.validators.name import valid_name
-from lp.testing import TestCaseWithFactory
 from lp.translations.enums import RosettaImportStatus
 from lp.translations.interfaces.translationimportqueue import (
     ITranslationImportQueue,

=== modified file 'lib/lp/translations/tests/test_translationimportqueue.py'
--- lib/lp/translations/tests/test_translationimportqueue.py	2011-12-28 17:03:06 +0000
+++ lib/lp/translations/tests/test_translationimportqueue.py	2011-12-30 01:48:17 +0000
@@ -10,17 +10,12 @@
 from zope.component import getUtility
 from zope.security.proxy import removeSecurityProxy
 
+from lp.app.interfaces.launchpad import ILaunchpadCelebrities
 from lp.services.database.lpstorm import (
     ISlaveStore,
     IStore,
     )
-from canonical.librarian.testing.fake import FakeLibrarian
-from lp.testing.layers import (
-    LaunchpadFunctionalLayer,
-    LaunchpadZopelessLayer,
-    ZopelessDatabaseLayer,
-    )
-from lp.app.interfaces.launchpad import ILaunchpadCelebrities
+from lp.services.librarianserver.testing.fake import FakeLibrarian
 from lp.services.tarfile_helpers import LaunchpadWriteTarFile
 from lp.services.worlddata.interfaces.language import ILanguageSet
 from lp.testing import (
@@ -29,6 +24,11 @@
     )
 from lp.testing.factory import LaunchpadObjectFactory
 from lp.testing.fakemethod import FakeMethod
+from lp.testing.layers import (
+    LaunchpadFunctionalLayer,
+    LaunchpadZopelessLayer,
+    ZopelessDatabaseLayer,
+    )
 from lp.translations.enums import RosettaImportStatus
 from lp.translations.interfaces.translationimportqueue import (
     ITranslationImportQueue,

=== modified file 'lib/lp/translations/tests/test_translationtemplatesbuildbehavior.py'
--- lib/lp/translations/tests/test_translationtemplatesbuildbehavior.py	2011-12-29 05:29:36 +0000
+++ lib/lp/translations/tests/test_translationtemplatesbuildbehavior.py	2011-12-30 01:10:37 +0000
@@ -14,9 +14,6 @@
 from zope.component import getUtility
 from zope.security.proxy import removeSecurityProxy
 
-from lp.services.config import config
-from canonical.librarian.utils import copy_and_close
-from lp.testing.layers import LaunchpadZopelessLayer
 from lp.app.interfaces.launchpad import ILaunchpadCelebrities
 from lp.buildmaster.enums import BuildStatus
 from lp.buildmaster.interfaces.buildfarmjobbehavior import (
@@ -27,9 +24,12 @@
     SlaveTestHelpers,
     WaitingSlave,
     )
+from lp.services.config import config
 from lp.services.librarian.interfaces import ILibraryFileAliasSet
+from lp.services.librarian.utils import copy_and_close
 from lp.testing import TestCaseWithFactory
 from lp.testing.fakemethod import FakeMethod
+from lp.testing.layers import LaunchpadZopelessLayer
 from lp.translations.enums import RosettaImportStatus
 from lp.translations.interfaces.translationimportqueue import (
     ITranslationImportQueue,

=== modified file 'lib/lp/translations/utilities/gettext_po_importer.py'
--- lib/lp/translations/utilities/gettext_po_importer.py	2010-12-02 16:13:51 +0000
+++ lib/lp/translations/utilities/gettext_po_importer.py	2011-12-30 01:14:33 +0000
@@ -10,7 +10,7 @@
 from zope.component import getUtility
 from zope.interface import implements
 
-from canonical.librarian.interfaces import ILibrarianClient
+from lp.services.librarian.interfaces.client import ILibrarianClient
 from lp.translations.interfaces.translationfileformat import (
     TranslationFileFormat,
     )

=== modified file 'lib/lp/translations/utilities/mozilla_xpi_importer.py'
--- lib/lp/translations/utilities/mozilla_xpi_importer.py	2010-12-02 16:13:51 +0000
+++ lib/lp/translations/utilities/mozilla_xpi_importer.py	2011-12-30 01:14:33 +0000
@@ -14,7 +14,7 @@
 from zope.component import getUtility
 from zope.interface import implements
 
-from canonical.librarian.interfaces import ILibrarianClient
+from lp.services.librarian.interfaces.client import ILibrarianClient
 from lp.translations.interfaces.translationfileformat import (
     TranslationFileFormat,
     )

=== modified file 'lib/lp/translations/utilities/tests/test_file_importer.py'
--- lib/lp/translations/utilities/tests/test_file_importer.py	2011-12-28 17:03:06 +0000
+++ lib/lp/translations/utilities/tests/test_file_importer.py	2011-12-30 01:48:17 +0000
@@ -11,13 +11,13 @@
 from zope.component import getUtility
 from zope.security.proxy import removeSecurityProxy
 
-from canonical.librarian.testing.fake import FakeLibrarian
+from lp.registry.interfaces.person import IPersonSet
+from lp.services.librarianserver.testing.fake import FakeLibrarian
+from lp.testing import TestCaseWithFactory
 from lp.testing.layers import (
     LaunchpadZopelessLayer,
     ZopelessDatabaseLayer,
     )
-from lp.registry.interfaces.person import IPersonSet
-from lp.testing import TestCaseWithFactory
 from lp.translations.enums import TranslationPermission
 from lp.translations.interfaces.potemplate import IPOTemplateSet
 from lp.translations.interfaces.side import TranslationSide

=== modified file 'scripts/ftpmaster-tools/sync-source.py'
--- scripts/ftpmaster-tools/sync-source.py	2011-10-15 00:25:33 +0000
+++ scripts/ftpmaster-tools/sync-source.py	2011-12-30 01:48:17 +0000
@@ -34,7 +34,6 @@
     cursor,
     sqlvalues,
     )
-from canonical.librarian.client import LibrarianClient
 from lp.archiveuploader.utils import (
     DpkgSourceError,
     extract_dpkg_source,
@@ -42,6 +41,7 @@
 from lp.registry.interfaces.distribution import IDistributionSet
 from lp.registry.interfaces.person import IPersonSet
 from lp.registry.interfaces.pocket import PackagePublishingPocket
+from lp.services.librarian.client import LibrarianClient
 from lp.services.scripts.base import (
     LaunchpadScript,
     LaunchpadScriptFailure,

=== modified file 'utilities/smoke-test-librarian.py'
--- utilities/smoke-test-librarian.py	2011-12-21 20:23:01 +0000
+++ utilities/smoke-test-librarian.py	2011-12-30 02:24:09 +0000
@@ -6,17 +6,18 @@
 """Perform simple librarian operations to verify the current configuration.
 """
 
-import _pythonpath # Not lint, actually needed.
+import _pythonpath
 
 import sys
 
 from zope.component import getUtility
-from lp.services.scripts import execute_zcml_for_scripts
-from canonical.librarian.interfaces import (
+
+from lp.services.librarian.interfaces.client import (
+    ILibrarianClient,
     IRestrictedLibrarianClient,
-    ILibrarianClient,
     )
-from canonical.librarian.smoketest import do_smoketest
+from lp.services.librarian.smoketest import do_smoketest
+from lp.services.scripts import execute_zcml_for_scripts
 
 
 if __name__ == '__main__':

